Scriptname _SSPConjureShadowScript extends activemagiceffect  

ImagespaceModifier Property Shadow_Imod auto
Sound Property Shadow_Sound auto
Perk Property buff auto
Perk Property cooldown auto
VisualEffect Property cast_effect auto

Actor caster;

int counter = 0;
int cjs_instance;

Event OnEffectStart(Actor akTarget, Actor akCaster)
	float lightlevel = akCaster.GetLightLevel();
	if (lightlevel >= 90)
		Debug.Notification("Your surroundings are too bright and the spell fails.");
		self.Dispel();
	else
		cast_effect.Play(akCaster, 2.0);
		cjs_instance = Shadow_Sound.Play(akCaster);
		Shadow_Imod.Apply();
		akCaster.addPerk(buff);
		akCaster.addPerk(cooldown);

		caster = akCaster;
		RegisterForSingleUpdate(2.0);
	endif
endEvent

Event OnUpdate()
	float lightlevel = caster.GetLightLevel();

	if (counter > 2)
		cast_effect.Play(caster, 2.0);
		counter = 0;
	else
		counter += 1;
	endif

	if (lightlevel >= 120)
		Debug.Notification("The shadows quickly dissipate as you step inside a bright area.");

		Shadow_Imod.Remove();
		caster.removePerk(buff);
		Sound.StopInstance(cjs_instance);
	else
		RegisterForSingleUpdate(2.0);
	endif
endEvent

Event OnEffectFinish(Actor akTarget, Actor akCaster)
	Shadow_Imod.Remove();
	caster.removePerk(buff);
	Sound.StopInstance(cjs_instance);
endEvent