Scriptname _SSPMenuManagerScript extends SKI_ConfigBase

GlobalVariable Property _SSPShadowboltShowMessage Auto
GlobalVariable Property _SSPLifeTapHealth Auto
GlobalVariable Property _SSPLifeTapMagicka Auto
GlobalVariable Property _SSPCrushStaggerChance Auto
GlobalVariable Property _SSPCTLowLevelThreshold auto
GlobalVariable Property _SSPCTLowHealthPercentage auto
GlobalVariable Property _SSPCTSlayFailChance auto
GlobalVariable Property _SSPShadowformHealPercent auto

int ShadowboltShowMessage;
int LifeTapHealth;
int LifeTapMagicka;
int CrushStaggerChance;
int CTLowLevelThreshold;
int CTLowHealthPercentage;
int CTSlayFailChance;
int ShadowformHealPercent;

Event OnPageReset(String page)
	SetCursorFillMode(TOP_TO_BOTTOM);
	SetCursorPosition(0);

	AddHeaderOption("Life Tap");
	LifeTapHealth = AddSliderOption("Health", _SSPLifeTapHealth.GetValueInt(), "{0}%");
	LifeTapMagicka = AddSliderOption("Magicka", _SSPLifeTapMagicka.GetValueInt(), "{0}%");
	AddEmptyOption();
	
	AddHeaderOption("Crushing Darkness");
	CrushStaggerChance = AddSliderOption("Stagger chance", _SSPCrushStaggerChance.GetValueInt(), "{0}%");
	AddEmptyOption();

	AddHeaderOption("Creeping Terror");
	CTLowLevelThreshold = AddSliderOption("Low level threshold", _SSPCTLowLevelThreshold.GetValueInt(), "{0}");
	CTLowHealthPercentage = AddSliderOption("Low health threshold", _SSPCTLowHealthPercentage.GetValueInt(), "{0}%");
	CTSlayFailChance = AddSliderOption("Slay failure chance", _SSPCTSlayFailChance.GetValueInt(), "{0}%");

	SetCursorPosition(1);

	AddHeaderOption("Shadowform ");
	ShadowformHealPercent = AddSliderOption("Healing", _SSPShadowformHealPercent.GetValueInt(), "{0}%");
	AddEmptyOption();

	AddHeaderOption("Notifications");
	ShadowboltShowMessage = AddToggleOption("Shadowbolt damage notifications", _SSPShadowboltShowMessage.GetValueInt());
endEvent

Event OnOptionHighlight(int option)
	if (option == ShadowboltShowMessage)
		SetInfoText("Display bonus damage notifications every Shadowbolt cast.");
	elseif (option == LifeTapHealth)
		SetInfoText("How much health is drained when Life Tap is cast.");
	elseif (option == LifeTapMagicka)
		SetInfoText("How much magicka is restored when Life Tap is cast.");
	elseif (option == CrushStaggerChance)
		SetInfoText("The chance of triggering a stagger effect each tick.");
	elseif (option == CTLowLevelThreshold)
		SetInfoText("A target is considered \"low level\" if its level is at least this much lower than yours. Low level targets are always instantly slain if the spell does not fail (see \"Slay failure chance\"). The spell NEVER fails if low level target health is less than or equal to the \"Low health threshold\" value.");
	elseif (option == CTLowHealthPercentage)
		SetInfoText("Targets that have this much health or less are instantly slain if the spell does not fail (see \"Slay failure chance\"). Low level targets that have this much health or less are ALWAYS slain.");
	elseif (option == CTSlayFailChance)
		SetInfoText("Each slay effect has a chance not to be triggered. The effect is ALWAYS triggered if the target is low level and its health is less than or equal to the \"Low health threshold\" value.");
	elseif (option == ShadowformHealPercent)
		SetInfoText("The percentage of shadow damage dealt leeched as health while Shadowform is active.");
	endif
endEvent

Event OnOptionSliderOpen(int option)
	if (option == LifeTapHealth)
		SetSliderDialogStartValue(_SSPLifeTapHealth.GetValueInt());
		SetSliderDialogDefaultValue(20);
		SetSliderDialogRange(5, 50);
		SetSliderDialogInterval(1);
	elseif (option == LifeTapMagicka)
		SetSliderDialogStartValue(_SSPLifeTapMagicka.GetValueInt());
		SetSliderDialogDefaultValue(25);
		SetSliderDialogRange(5, 50);
		SetSliderDialogInterval(1);
	elseif (option == CrushStaggerChance)
		SetSliderDialogStartValue(_SSPCrushStaggerChance.GetValueInt());
		SetSliderDialogDefaultValue(50);
		SetSliderDialogRange(0, 100);
		SetSliderDialogInterval(1);
	elseif (option == CTLowLevelThreshold)
		SetSliderDialogStartValue(_SSPCTLowLevelThreshold.GetValueInt());
		SetSliderDialogDefaultValue(5);
		SetSliderDialogRange(1, 20);
		SetSliderDialogInterval(1);
	elseif (option == CTLowHealthPercentage)
		SetSliderDialogStartValue(_SSPCTLowHealthPercentage.GetValueInt());
		SetSliderDialogDefaultValue(35);
		SetSliderDialogRange(0, 60);
		SetSliderDialogInterval(1);
	elseif (option == CTSlayFailChance)
		SetSliderDialogStartValue(_SSPCTSlayFailChance.GetValueInt());
		SetSliderDialogDefaultValue(25);
		SetSliderDialogRange(0, 99);
		SetSliderDialogInterval(1);
	elseif (option == ShadowformHealPercent)
		SetSliderDialogStartValue(_SSPShadowformHealPercent.GetValueInt());
		SetSliderDialogDefaultValue(10);
		SetSliderDialogRange(0, 50);
		SetSliderDialogInterval(1);
	endif
endEvent

Event OnOptionSliderAccept(int option, float value)
	if (option == LifeTapHealth)
		_SSPLifeTapHealth.SetValue(value);
		SetSliderOptionValue(option, value, "{0}%");
	elseif (option == LifeTapMagicka)
		_SSPLifeTapMagicka.SetValue(value);
		SetSliderOptionValue(option, value, "{0}%");
	elseif (option == CrushStaggerChance)
		_SSPCrushStaggerChance.SetValue(value);
		SetSliderOptionValue(option, value, "{0}%");
	elseif (option == CTLowLevelThreshold)
		_SSPCTLowLevelThreshold.SetValue(value);
		SetSliderOptionValue(option, value, "{0}");
	elseif (option == CTLowHealthPercentage)
		_SSPCTLowHealthPercentage.SetValue(value);
		SetSliderOptionValue(option, value, "{0}%");
	elseif (option == CTSlayFailChance)
		_SSPCTSlayFailChance.SetValue(value);
		SetSliderOptionValue(option, value, "{0}%");
	elseif (option == ShadowformHealPercent)
		_SSPShadowformHealPercent.SetValue(value);
		SetSliderOptionValue(option, value, "{0}%");
	endif
endEvent

Event OnOptionSelect(int option)
	if (option == ShadowboltShowMessage)
		if (_SSPShadowboltShowMessage.GetValue() == 1)
			_SSPShadowboltShowMessage.SetValue(0);
			SetToggleOptionValue(ShadowboltShowMessage, 0);
		elseif (_SSPShadowboltShowMessage.GetValue() == 0)
			_SSPShadowboltShowMessage.SetValue(1);
			SetToggleOptionValue(ShadowboltShowMessage, 1);
		endif
	endif
endEvent