Scriptname _SSPMindControlScript extends activemagiceffect  

bool firstperson;
Form righthand;
Form lefthand;
Perk Property invis auto;
Activator Property marker auto;

Faction[] factions;
int[] ranks;
float confidence;
float aggression;

Actor target;
Idle Property canceljump auto;
bool active = false;

ImagespaceModifier Property MindControl_Imod auto
Sound Property MindControl_Sound auto
int mcs_instance;

Event OnEffectStart(Actor akTarget, Actor akCaster)
	if (akTarget.GetLevel() > self.GetMagnitude() && !akTarget.IsEssential())
		self.Dispel();
		Debug.Notification(akTarget.GetLeveledActorBase().GetName() + " is too powerful for Mind Control.");
	else
		active = true;

		if (Game.GetCameraState() == 0)
			firstperson = true;
		endif
	
		righthand = akCaster.GetEquippedObject(1);
		lefthand = akCaster.GetEquippedObject(0);
	
		if (righthand as Spell)
			akCaster.UnequipSpell(righthand as Spell, 1);
		else
			akCaster.UnequipItemEx(righthand, 1);
		endif
	
		if (lefthand as Spell)
			akCaster.UnequipSpell(lefthand as Spell, 0);
		else
			akCaster.UnequipItemEx(lefthand, 2);
		endif

		if (!akCaster.IsSneaking())
			akCaster.StartSneaking();
		endif
		akCaster.AddPerk(invis);

		Game.ForceThirdPerson();
		Game.DisablePlayerControls(false, false, true, false, false, true, true, true, 0);
		akTarget.SetPlayerControls(true);
		akTarget.EnableAI(true);
		Game.SetCameraTarget(akTarget);
		Game.SetPlayerAIDriven(true);

		confidence = akTarget.GetAV("Confidence");
		aggression = akTarget.GetAV("Aggression");
		akTarget.SetAV("Confidence", 0);
		akTarget.SetAV("Aggression", 3);
		akTarget.StopCombat();
		akTarget.SetAlert(true);
		ObjectReference ref = akTarget.PlaceAtMe(marker, 1);
		;Debug.SendAnimationEvent(akTarget, "StaggerStart");
		ref.KnockAreaEffect(1.0, 50);
		ref.Delete();
		target = akTarget;

		MindControl_Imod.Apply();
		mcs_instance = MindControl_Sound.Play(akTarget);
	
		RegisterForControl("Activate");
		RegisterForAnimationEvent(akTarget, "JumpStart");
		RegisterForAnimationEvent(akTarget, "JumpFall");
		RegisterForAnimationEvent(akTarget, "JumpFallDirectional");
		RegisterForSingleUpdate(2.0);
	endif
endEvent

Event OnUpdate()
	if (active)
		target.SetAV("Confidence", 0);
		target.SetAV("Aggression", 3);
		target.SetAlert(true);
	endif
endEvent

Event OnEffectFinish(Actor akTarget, Actor akCaster)
	if (active)
		active = false;
		akTarget.SetPlayerControls(false);
		akTarget.EnableAI(true);
		Game.EnablePlayerControls(true, true, true, true, true, true, true, true, 0);
		Game.SetPlayerAIDriven(false);
		Game.GetPlayer().EnableAI(true);
		Game.SetCameraTarget(akCaster);
		akTarget.SetAV("Confidence", confidence);
		akTarget.SetAV("Aggression", aggression);
		akTarget.StopCombat();
		akTarget.SetAlert(true);
	
		MindControl_Imod.Remove();
		Sound.StopInstance(mcs_instance);

		akCaster.RemovePerk(invis);

		if (righthand as Spell)
			akCaster.EquipSpell(righthand as Spell, 1);
		else
			akCaster.EquipItemEx(righthand, 1, false, false);
		endif
	
		if (lefthand as Spell)
			akCaster.EquipSpell(lefthand as Spell, 0);
		else
			akCaster.EquipItemEx(lefthand, 2, false, false);
		endif

		if (firstperson == true)
			Game.ForceFirstPerson();
		endif
	endif
endEvent

Event OnControlUp(string control, float HoldTime)
	if (control == "Activate")
		self.Dispel();
	endif
endEvent

Event OnAnimationEvent(ObjectReference akSource, string asEventName)
	;target.PlayIdle(canceljump);
	;Debug.SendAnimationEvent(target, "StaggerStart");
	ObjectReference ref = target.PlaceAtMe(marker, 1);
	ref.KnockAreaEffect(0.75, 50);
	ref.Delete();
endEvent