Scriptname _SSPShadowformScript extends activemagiceffect

Actor caster
Spell Property shadowform_spell auto
Perk Property shadowform_perk auto
VisualEffect Property cast_effect auto
VisualEffect Property shader_effect auto
VisualEffect Property shader_effect2 auto
Sound Property cast_sound auto

Event OnEffectStart(Actor akTarget, Actor akCaster)
	if (akCaster.HasPerk(shadowform_perk))
		self.Dispel();
		akCaster.DispelSpell(shadowform_spell);
		Debug.Notification("Shadowform is no longer active");
	else
		float max_magicka = akCaster.GetActorValue("Magicka") / akCaster.GetActorValuePercentage("Magicka");
		akCaster.damageAV("Magicka", max_magicka*0.8);
		akCaster.addPerk(shadowform_perk);
		cast_effect.Play(akCaster, 2.0);
		shader_effect2.Play(akCaster);
		if (Game.GetCameraState() != 0)
			shader_effect.Play(akCaster);
		endif
		cast_sound.Play(akCaster);

		caster = akCaster;
		RegisterForCameraState();
	endif
endEvent

Event OnEffectFinish(Actor akTarget, Actor akCaster)
	UnregisterforCameraState();
	akCaster.removePerk(shadowform_perk);
	shader_effect.Stop(akCaster);
	shader_effect2.Stop(akCaster);
endEvent

Event OnPlayerCameraState(int oldState, int newState)
	if (newState == 0)
		shader_effect.Stop(caster);
	else
		shader_effect.Play(caster, -1);
	endIf	
endEvent
