Scriptname _SSPSpellManagerScript extends Quest  

Quest Property leveledmanager auto
;Quest Property damanager auto

Perk Property hexmaster auto

Spell Property sear1 auto
Spell Property sear2 auto
Spell Property sear3 auto
Spell Property sear4 auto

Spell Property ds1 auto
Spell Property ds2 auto
Spell Property ds3 auto
Spell Property ds4 auto

Spell Property bolt1 auto
Spell Property bolt2 auto
Spell Property bolt3 auto

Spell Property crush1 auto
Spell Property crush2 auto

Spell Property exhaustion1 auto
Spell Property exhaustion2 auto

Spell Property fragility1 auto
Spell Property fragility2 auto

Spell Property atronach1 auto
Spell Property atronach2 auto
Spell Property atronach3 auto

GlobalVariable Property version auto
float internal_version = 1.0;

Event OnInit()
	RegisterForSingleUpdate(10.0);
endEvent

Event OnUpdate()
	; Version checks

	; For older versions. I hope it is fine.
	if (internal_version == 1.0)
		UnregisterForUpdate();
	endif

	if (internal_version < version.GetValue())
		Debug.Notification("Upgrading Shadow Spell Package, please wait...");
	
		(leveledmanager as _SSPLeveledItemManagerScript).PopulateLists();
		;if (damanager.IsRunning())
		;	damanager.Stop();
		;	damanager.Reset();
		;endif
		;damanager.Start();

		int skse_version = SKSE.GetVersion();
		if (skse_version == 0)
			Debug.MessageBox("The Skyrim Script Extender (SKSE) is not running. A lot of Shadow Spell Package spells and abilities will not function properly. You have been warned.");
		endif

		internal_version = version.GetValue();
		Debug.Notification("Shadow Spell Package has been succesfully upgraded.");
		Debug.Notification("Shadow spells, staves and scrolls have been added to leveled lists.");
		Debug.Notification("You may need to wait a few days for the leveled lists to refresh.");
	endif

	;Spell watcher

	Actor playerRef = Game.GetPlayer();

	if (!playerRef.IsInCombat())
		if (playerRef.GetAV("Destruction") >= 25 && playerRef.HasSpell(sear1))
			playerRef.removeSpell(sear1);
			playerRef.addSpell(sear2);
			Debug.Notification("Your Sear spell has been empowered");
		endif
		if (playerRef.GetAV("Destruction") >= 50 && playerRef.HasSpell(sear2))
			playerRef.removeSpell(sear2);
			playerRef.addSpell(sear3);
			Debug.Notification("Your Sear spell has been empowered");
		endif
		if (playerRef.GetAV("Destruction") >= 75 && playerRef.HasSpell(sear3))
			playerRef.removeSpell(sear3);
			playerRef.addSpell(sear4);
			Debug.Notification("Your Sear spell has been empowered");
		endif

		if (playerRef.GetAV("Destruction") >= 25 && playerRef.HasSpell(ds1))
			playerRef.removeSpell(ds1);
			playerRef.addSpell(ds2);
			Debug.Notification("Your Drain Soul spell has been empowered");
		endif
		if (playerRef.GetAV("Destruction") >= 50 && playerRef.HasSpell(ds2))
			playerRef.removeSpell(ds2);
			playerRef.addSpell(ds3);
			Debug.Notification("Your Drain Soul spell has been empowered");
		endif
		if (playerRef.GetAV("Destruction") >= 75 && playerRef.HasSpell(ds3))
			playerRef.removeSpell(ds3);
			playerRef.addSpell(ds4);
			Debug.Notification("Your Drain Soul spell has been empowered");
		endif

		if (playerRef.GetAV("Destruction") >= 50 && playerRef.HasSpell(bolt1))
			playerRef.removeSpell(bolt1);
			playerRef.addSpell(bolt2);
			Debug.Notification("Your Shadowbolt spell has been empowered");
		endif
		if (playerRef.GetAV("Destruction") >= 75 && playerRef.HasSpell(bolt2))
			playerRef.removeSpell(bolt2);
			playerRef.addSpell(bolt3);
			Debug.Notification("Your Shadowbolt spell has been empowered");
		endif

		if (playerRef.GetAV("Destruction") >= 75 && playerRef.HasSpell(crush1))
			playerRef.removeSpell(crush1);
			playerRef.addSpell(crush2);
			Debug.Notification("Your Crushing Darkness spell has been empowered");
		endif

		if (playerRef.HasPerk(hexmaster) && playerRef.HasSpell(exhaustion1))
			playerRef.removeSpell(exhaustion1);
			playerRef.addSpell(exhaustion2);
		endif
		if (playerRef.HasPerk(hexmaster) && playerRef.HasSpell(fragility1))
			playerRef.removeSpell(fragility1);
			playerRef.addSpell(fragility2);
		endif

		if (playerRef.GetAV("Conjuration") >= 50 && playerRef.HasSpell(atronach1))
			playerRef.removeSpell(atronach1);
			playerRef.addSpell(atronach2);
			Debug.Notification("Your Conjure Shadow Atronach spell has been empowered");
		endif
		if (playerRef.GetAV("Conjuration") >= 75 && playerRef.HasSpell(atronach2))
			playerRef.removeSpell(atronach2);
			playerRef.addSpell(atronach3);
			Debug.Notification("Your Conjure Shadow Atronach spell has been empowered");
		endif
	endif

	RegisterForSingleUpdate(10.0);
endEvent
